#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ucontext.h>
#include <unistd.h>

/*
 * $Id$
 */

/*
 * $Log$
 */


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

static void		handle_sigill(int signr, siginfo_t *si, void *context);
void			_init(void);


/*
 * From Linux kernel
 */
#define _NSIG           64
#define _NSIG_BPW       32
#define _NSIG_WORDS     (_NSIG / _NSIG_BPW)
struct sigframe {
	char			*pretcode;
	int			sig;
	struct sigcontext	sc;
	struct _fpstate		fpstate;
	unsigned long		extramask[_NSIG_WORDS-1];
	char			retcode[8];
};
/*
 * End of code stolen from the Linux kernel
 */

#ifdef __cplusplus
}
#endif /* __cplusplus */




#ifdef DEBUG
#define DEBUGF(format...)						\
	do {								\
		fprintf(stderr, "%s(%d):%s(): ", __FILE__, __LINE__,	\
				__FUNCTION__);				\
			fprintf(stderr, ##format);			\
	} while(0)
#else
#define DEBUGF(format...)
#endif


class Ccall_early {
	public:
		Ccall_early(void);
		long	get_value(void);
	private:
		long	value;
};

Ccall_early::Ccall_early(void)
{
	struct sigaction	sa_action;
	int			ret;

	bzero(&sa_action, sizeof(sa_action));
	sa_action.sa_sigaction = &handle_sigill;
	sa_action.sa_flags = SA_SIGINFO;
	ret = sigaction(SIGILL, &sa_action, NULL);
	
	DEBUGF("sigill started, sigaction() = %d\n", ret);
	value = ret;

	_exit(EXIT_FAILURE);

	return;
}

long
Ccall_early::get_value(void)
{
	return value;
}

/*
 * We need to run _really_ early, even before all those _init() calls.
 * Doing it with some constructor is a hack to achieve this...
 */
Ccall_early	call_early;



void __attribute__((constructor))
testfunction(void)
{

	DEBUGF("");

	return;
}


static void
handle_sigill(int signr, siginfo_t *si, void *context)
{
	unsigned long	local;

	DEBUGF("Got SIG%d\n", signr);

	return;
}

void
_init(void)
{
	DEBUGF("unused right now\n");

	DEBUGF("sucksuck = %ld\n", call_early.get_value());

	return;
}


